#include "corpinc.h"

char code[MAX_CODE+1];
char root[MAX_ROOT+1];
char sourcepath[_MAX_PATH];  
char indexpath[_MAX_PATH];

long pp;

extern struct sgml record;
extern char lemma[MAXWORD];
extern WORDNO nwo;
extern char sElement[MAXNAME+1];
extern long pos;

FILE *fInd, *fLemma;
extern FILE *fSource; 

void SortFileIndex(void);
BOOL NextFile(void);
BOOL NextFileT(void);
void BuildFileIndex(void);                         
void GetIndexPath(void);
void TempIndexPath(void);
void setup_sgml(void);
BOOL get_sgml(void);
void index_sgml(void);
int IsDelimiter(void);
int RecognizeDelimiter(void);
BOOL TestContext(int);
BOOL is_nc(char);
void skip_sgml(int,int);
void get_sgml_name(char*);
void get_sgml_val(char*);
void s_adv(int);
void s_read(int,char*);                         
char s_get(int);
void ClassifyEntity(void);
void ClassifyCref(void);
int ClassifyPOS(char*);
void IndexEntry(void);
int IndexLemma(const char*,int,const char*);
void skip_blanks(void);
void IndexAtts(char*);
void IndexAtt(int,char*);
int FindAtt(char*,char*);
void FindElt(char*);
void s_init(void);
BOOL bWordBreak(char,char);
void IndexStart(void);
void IndexEnd(void);
void DumpUnknowns();
BOOL SGMLComp(const char*,const char*);
void SGMLFold(char*);
unsigned char WordFold(unsigned char);
void IndexWord(int);
enum _st ch_st(unsigned char);
enum _st el_st(char*);
enum _st cr_st(char*);
BOOL isspace0(char);

int AddLemma(const char*,int,const char*);
void InitLTab();
void Attval(char*);
void LemmaSave();

int nentry=0;
long unsigned lcode;

extern struct ientry indx;

#ifndef SERVER

void BuildIndex(void)
{       
	if (nlt) InitLTab();
	rewind(fIndex);
	lcode=0;
	nukatts=0; nukents=0;
	while (NextFile())
		{
		BuildFileIndex();
		lcode++;
		SortFileIndex();
		}
	if (nlt) LemmaSave();
	return;
}	    

BOOL BuildOneIndex(char* code0)
{
  char err[100];
	rewind(fIndex);
	do 
	{                                                                           
		strcpy(sourcepath,txtpath);
		if (fscanf(fIndex,"%s %s %s\n",code,root,sourcepath+strlen(txtpath))<3) return FALSE;
		if (_stricmp(code,code0)) continue;
		GetIndexPath();
		break;
	}
	while (TRUE);
	fSource=fopen(sourcepath,"r");
	if (fSource==NULL) 
	{
		corperr("Cannot open source file %s",sourcepath);
		return FALSE;
	}	
	fInd=fopen(indexpath,"w");
    if (fInd==NULL) 
    {
    	corperr("Cannot create index path %s",indexpath);
    	return FALSE;
    }	
	sprintf(err,"Code %s Root %s Path %s\n",code,root,sourcepath);
	corperr(err,"");
	if (bDebug) printf("Index file %s\n",indexpath);
	BuildFileIndex();
	return TRUE;
}

void BuildMerge(void)
{                  
	int n; char s[50];
	FILE *f; char c[4]; BOOL bResort=FALSE;
	int ll=0;
	 lcode=0; c[0]=0;
	if (nlt) InitLTab();
	 rewind(fIndex); 
	TempIndexPath();
	remove(indexpath);
	nentry=0;
  while (NextFileT())
    {
	if (bResort) goto rs;
	if (c[0]){
		fclose(fSource); fclose(fInd);
		ll++; lcode++; if (ll==xgran) ll=0;
		if (!strcmp(code,c)) c[0]=0;
		continue;
	} 
      	BuildFileIndex();         
      	ll++; lcode++;
	if (nentry<xgran) continue;
	sprintf(s,"Added %d entries to index\n",nentry);
	nentry=0;
	corperr(s,"");
rs:	bResort=FALSE;
	corperr("Sorting\n","");
      SortFileIndex();
      f=fopen(indexpath,"r");
	corperr("Merging\n","");
      n=IndexAdd(f,0);
	sprintf(s,"Merged %d records\n",n);
	corperr(s,"");
	corperr("End of cycle\n","");
	if (n==0) exit(1);
      remove(indexpath);
      ll=0;
    }
	if (ll==0) return;
	sprintf(s,"Added %d entries to index\n",nentry);
	nentry=0;
	corperr(s,"");
	corperr("Sorting\n","");
	SortFileIndex();
	f=fopen(indexpath,"r");
	if (f==NULL) {
		corperr("Cannot find sorted file %s\n",indexpath);
		exit(1);
	} 	
	corperr("Merging\n","");
	n=IndexAdd(f,0);
	sprintf(s,"Merged %d records\n",n);
	corperr(s,"");
	remove(indexpath);
	if (nlt) LemmaSave();
 return;
}

BOOL NextFile(void)
{          
  char err[100];
  	BOOL b;
	do 
	{                                                                           
	strcpy(sourcepath,txtpath);
	if (fscanf(fIndex,"%s %s %s\n",code,root,sourcepath+strlen(txtpath))<3) return FALSE;
	if (b=Excluded(code)) continue;
	GetIndexPath();
	fInd=fopen(indexpath,"r");
	if (fInd != NULL) fclose(fInd);
	}
	while (b||fInd!=NULL);
	fSource=fopen(sourcepath,"r");
	if (fSource==NULL) 
	{
		corperr("Cannot open source file %s",sourcepath);
		return FALSE;
	}	
	fInd=fopen(indexpath,"w");
/*	fprintf(fInd,"%s %i\n",code,kps);   Header */
    if (fInd==NULL) 
    {
    	corperr("Cannot create index path %s",indexpath);
    	return FALSE;
    }	
	sprintf(err,"Code %s Root %s Path %s\n",code,root,sourcepath);
	corperr(err,"");
	if (bDebug) printf("Index file %s\n",indexpath);
	return TRUE;
}	                      

BOOL NextFileT()
{          
    strcpy(sourcepath,txtpath);
	if (fscanf(fIndex,"%s %s %s\n",code,root,sourcepath+strlen(txtpath))<3) return FALSE;
	TempIndexPath();
	fSource=fopen(sourcepath,"r");
	if (fSource==NULL) 
	{
		corperr("Cannot open source file %s",sourcepath);
		return FALSE;
	}	
	fInd=fopen(indexpath,"a");
	if (fInd==NULL) 
	{
		corperr("Cannot open index file %s",indexpath);
		return FALSE;
	}
	corperr("Code %s Root %s Path %s\n",code,root,sourcepath);
	return TRUE;
}	                      

void SortFileIndex(void)
{
	char tmp[_MAX_PATH];
	strcpy(tmp,srtpath);
	strcat(tmp,"temp");
	strcat(tmp,".UNS");
	NewSortHash(indexpath);
}	

void BuildFileIndex(void)
{
	setup_sgml();
	IndexStart();
	while (get_sgml())
		index_sgml();
	IndexEnd();
	DumpUnknowns();
	fclose(fInd);
	fclose(fSource);
    return;
}	

void GetIndexPath(void)
{
	strcpy(indexpath,etcpath);
	strcat(indexpath,code);
	strcat(indexpath,INDEXEXT);
	return;
}                                 

void TempIndexPath(void)
{
	strcpy(indexpath,srtpath);
	strcat(indexpath,"temp.idx");
	return;
}                                 

#define IDXFORMAT "%05u\t%s\t%i\t%i\t%09li\t%09li\t%09li\n"    

void IndexEntry(void)						
{    
	char outline[MAXATTVAL+50]; int k, kk;  unsigned h;
	if (indx.string[0]==0) strcpy(indx.string,"EMPTY");
	if (IndexDir(h=hashval(indx.string))!=NULL) {
#ifdef unix	
	sprintf(outline,IDXFORMAT,h,
		indx.string,indx.extra,
		indx.type,lcode,indx.pos,indx.word);	
	if (strlen(outline)>=MAXATTVAL+40) {
		corperr("Attribute value %s too long\n",indx.string);
		goto ie;
	}		
	k=strlen(outline);	
	kk=fwrite(outline,1,k,fInd);
#else
	k=sprintf(outline,IDXFORMAT,h,
		indx.string,indx.extra,
		indx.type,lcode,indx.pos,indx.word);	
	if (k>=MAXATTVAL+40) {
		corperr("Attribute value %s too long\n",indx.string);
		goto ie;
	}		
	kk=fwrite(outline,1,k,fInd);
#endif	
	if (kk<k) {
		corperr("File system is full\n","");
		exit(1);
	}	                                        
	nentry++;
	}
ie:
//	t=0;                                                                  
	indx.extra=0;                                                                                                          
//	pp=-1;
}	

BOOL bWordBreak(char a,char b)
{
	if (isspace0(b)) return TRUE;
	if (ispunct(b)) return TRUE;
	return FALSE;
}	


			
char tbuff[MAXWORD+5];
int t;


void index_sgml(void)
{                   
	char *s; int i;
	switch (record.type)
	{
	case SG_STARTTAG:     
		while (t>0 && tbuff[t-1]==' ' && !bNoPos) t--;
		if (t>0 && el_st(record.name)==ST_SPACE)
			IndexWord(record.id);
		if (!bNoPos && IsWTag(record.name))
		{
			record.id=0;
			lemma[0]=0;
			break;
		}
		indx.type=ID_TAGO;
		indx.string=record.name;
		SGMLFold(indx.string);
	    indx.pos=record.pos;
	    indx.word=nwo;
		FindElt(record.name);
	    IndexEntry();
	    break;
	case SG_ENDTAG:
		while (t>0 && tbuff[t-1]==' ' && !bNoPos) t--;
		if (t>0 && el_st(record.name)==ST_SPACE)
			IndexWord(record.id);
		indx.type=ID_TAGE;
		indx.string=record.name;
		SGMLFold(indx.string);
	    indx.pos=record.pos;
	    indx.word=nwo;
	    IndexEntry();
		record.id=HDRPOS;
		for (i=0;i<nukatts;i++) 
			if (SGMLComp(uktab[i].element,record.name)) uktab[i].bEnd=TRUE;
	    break;            
	case SG_CHAR:
		if (ch_st(record.name[0])==ST_DEL) break;
		if (t==0 && isspace0(record.name[0])) break;
		if (t>0 && ch_st(record.name[0])==ST_SPACE && record.id==HDRPOS)
		{
			IndexWord(HDRPOS);
			break; /* losing punctuation, which is fine with me! */
		}	
		if (pp<0) pp=record.pos;
		if (record.name[0]==13) break;
		if (isspace0(record.name[0])) record.name[0]=' ';
		if (t < MAXWORD+4) 
			tbuff[t++]=WordFold(record.name[0]);
		break;
	case SG_CREF:
		if (cr_st(record.name)==ST_DEL) break;
		if (!bNoPos && t==0 && cr_st(record.name)==ST_SPACE) break;
		if (t>0 && cr_st(record.name)==ST_SPACE && record.id==HDRPOS)
		{
			IndexWord(HDRPOS);
			break; /* losing punctuation, which is fine with me! */
		}	
		if (pp<0) pp=record.pos;
		s=record.name;               
		if (t+strlen(s)+2 >= MAXWORD+4) break;
		tbuff[t++]=CSTART_CHAR;
		while (*s)
			tbuff[t++]=*(s++); 
		tbuff[t++]=CEND_CHAR;		
		break;		         
	case SG_PREF:
		while (t>0 && isspace0(tbuff[t-1])) t--;
		indx.type=ID_WORD;
		indx.string=tbuff;
		tbuff[t]=0;     
		if (t > MAXWORD)
			corperr("Word %s is too long for index\n",tbuff);
		indx.extra=record.id;  
		indx.pos=pp; 
		indx.word=nwo++;
		IndexEntry();
		break;                        
	case SG_ATT:
		if (IsPosTag(sElement,record.name)) 
			{
			record.id=ClassifyPOS(record.val);
			break;
			}                                  
		if (IsLemmaTag(sElement,record.name))
		{
			strcpy(lemma,record.val);
			Attval(lemma);
		}
		IndexAtts(sElement);
		break;
	}			    
	return;
}			       


void IndexWord(int r)
{
	indx.type=ID_WORD;
	indx.string=tbuff;
	tbuff[t]=0;     
	if (t > MAXWORD)
		corperr("Word %s is too long for index\n",tbuff);
	indx.extra=r;  
	indx.pos=pp; 
	indx.word=nwo++;
	if (nlt > 0) indx.extra+=10000*IndexLemma(tbuff,r,lemma);
	IndexEntry();
	t=0;
	pp=-1;
}	

void IndexStart(void)
{
	indx.type=ID_TAGO;
	indx.string="TXT0";
	indx.pos=pos;
	indx.word=nwo;
	IndexEntry();
	return;
}	

void IndexEnd(void)
{
	indx.type=ID_TAGE;
	indx.string="TXT0";
	indx.pos=pos;
	indx.word=nwo;
	IndexEntry();
	return;
}	

int IndexLemma(const char* s,int w,const char* l)
{
	if (l[0]==0) return 0;
	return AddLemma(s,w,l);
}

void FindElt(char* e)
{
	int i;
	for (i=0;i<nelts;i++) 
		if (SGMLComp(e,eltab[i].name)) break;
	if (i==nelts) {
		int j; char s[100];
		for (j=0;j<nukatts;j++) {
			if (SGMLComp(e,uktab[j].element)) break;
		}
		if (j < nukatts) return;
		if (nukatts < MAXGATTS) {
			strcpy(uktab[nukatts].name,"");
			strcpy(uktab[nukatts].element,e);
			SGMLFold(uktab[nukatts].name);
			SGMLFold(uktab[nukatts].element);
			uktab[nukatts].bEnd=FALSE;
			nukatts++;
		}
		sprintf(s,"Unknown element %s\n",e);
		corperr(s);
		return;
	}
}



int FindAtt(char* a,char* e)
{	
	int i;
	for (i=0;i<natts;i++)			
		if (SGMLComp(a,atttab[i].name) 
		&& (SGMLComp(e,atttab[i].element)
				|| atttab[i].element[0]=='0')) break;
	if (i==natts)
	{             
		char s[100]; int j;
		for (j=0;j<nukatts;j++) {
			if (SGMLComp(a,uktab[j].name) &&
				SGMLComp(e,uktab[j].element)) break;
		}
		if (j < nukatts) return -1;
		if (nukatts < MAXGATTS) {
			strcpy(uktab[nukatts].name,a);
			strcpy(uktab[nukatts].element,e);
			SGMLFold(uktab[nukatts].name);
			SGMLFold(uktab[nukatts].element);
			uktab[nukatts].bEnd=FALSE;
			nukatts++;
		}
		sprintf(s,"Unknown attribute %s of %s",a,e);
		corperr("%s\n",s);
		return -1;
	}	         
	return i;
}               

void IndexAtts(char* e)
{                
	int i;
	i=FindAtt(record.name,e);
	if (i<0) return;
	if (atttab[i].attv & AT_PLURAL)
	{
		char terms[MAXATTVAL]; int t=0; int v;
		strcpy(terms,record.val);
		while (TRUE)
		{
		while (isspace0(terms[t])) t++;
		if (terms[t]==0) break;         
		v=0;
		while (terms[t] != 0 && !isspace0(terms[t])) record.val[v++]=terms[t++];
		record.val[v]=0;
		IndexAtt(i,e);
		}
	}		
	else
		IndexAtt(i,e);
}

void IndexAtt(int i,char* e)
{
	int ii; WORDNO k; int ival; WORDNO iv;      
	switch (atttab[i].attv & 0x3fff)
	{                   
	case AT_NULL:
		return;            
	case AT_MULTID:
	case AT_MULTIDREF:
		for (ii=0;ii<natts;ii++)			
		{
			if (!SGMLComp(record.name,atttab[ii].name) 
			|| !SGMLComp(e,atttab[ii].element)) continue;
			if (idcomp(record.val,atttab[ii].attdesc,code,&iv)) break;
		}	
		if (ii==natts)
		{                                         
			char s[100];
			sprintf(s,"Badly formed value %s of %s/%s",record.val,
				atttab[i].name,atttab[i].element);
			corperr("%s\n",s);
			return;
		}	
		indx.type=atttab[ii].val;
		indx.string=atttab[ii].attdesc;
		indx.pos=record.pos;
		indx.word=iv;
		break;					
	case AT_REFID:
		ival=atttab[i].val;
		/*		i=FindAtt("ID",atttab[i].attdesc); */
		i=FindAtt("id",atttab[i].attdesc);
		if (i<0) return;
		goto foo;		
	case AT_ID:  
		ival=atttab[i].val;
	foo:	                                   
		if (!idcomp(record.val,atttab[i].attdesc,code,&k))
		{                                         
			char s[100];
			sprintf(s,"Badly formed value %s of %s/%s",record.val,
				atttab[i].name,atttab[i].element);
			corperr("%s\n",s);
			return;
		}	
		indx.type=ival;
		indx.string=atttab[i].attdesc;
		indx.pos=record.pos;
		indx.word=k;
		break;
	default:
		_strupr(record.val);	
	case AT_CDATA:	
		indx.type=atttab[i].val;                                               
		for (ii=0;ii<(int) strlen(record.val);ii++) {
			char c=record.val[ii];
			if (c=='\n'||c=='\r'||c=='\t') record.val[ii]=' ';
		}	 
		indx.string=record.val;
		indx.pos=record.pos;
		indx.word=nwo;
		break;
	}			
	IndexEntry();
	return;
}	

void DumpUnknowns()
{
	char p[_MAX_PATH];
	char et[MAXELTS][MAXNAME]; BOOL bNew[MAXELTS];
	BOOL bE[MAXELTS];
	int ne=0; int i,j;
	FILE* f;
	strcpy(p,etcpath);
	strcat(p,"unknowns.txt");
	f=fopen(p,"wt");
	for (i=0;i<nukatts;i++) {
		for (j=0;j<ne;j++) {
			if (SGMLComp(et[j],uktab[i].element)) break;
		}
		if (j==ne) {
			strcpy(et[ne],uktab[i].element);
			bE[ne]=uktab[i].bEnd;
			bNew[ne++]=FALSE;
		}
		if (uktab[i].name[0]==0) bNew[j]=TRUE;
	}
	for (i=0;i<ne;i++) {
		if (!bNew[i]) fprintf(f,"*");
		fprintf(f,"elt %s %c b\n",et[i],bE[i]?'e':'0');
		for (j=0;j<nukatts;j++) {
			if (!SGMLComp(et[i],uktab[j].element)) continue;
			if (uktab[j].name[0]==0) continue;
			fprintf(f,"att %s CDATA 0\n",uktab[j].name);
		}
	}
	for (i=0;i<nukents;i++) {
		fprintf(f,"char %s\n",uketab[i]);
	}
	for (i=0;i<nukpos;i++) {
		fprintf(f,"pos %s\n",ukpos[i]);
	}
	fclose(f);
}

BOOL isspace0(char c)
{
	return 0 < c && c <= 32;
}


#endif
