#include "corpinc.h"



char incpath[_MAX_PATH];

char excpath[_MAX_PATH];

BOOL bDebug=TRUE;

FILE *fInclude, *fExclude, *fLog;

FILE *fIndex;



void MainPerform(int);    

void UtilMenu(void);

void GetParameters(void);

void GetInclude(void);

void GetExclude(void);

void CleanUp(void);

void Clean(void);

void GetIndex(void);

BOOL CrDir(char*);



struct menu umenu = 

	{"Utility menu",18,{

                      

        {MN_FINDEX,"Rescan file list"},              

		{MN_INDEX,"Build index"},

		{MN_MERGE,"Build hash index files"},
	{MN_BM,"Build and merge"},

		{MN_SORT,"Sort hash index files"},

		{MN_COMPRESS,"Compress index files"},                 

		{MN_DICT,"Build dictionary"},

		{MN_PINDEX,"Pack file index"},
		{MN_SIG,"Index signature"},
		{MN_BIBL,"Index bibliography"},
		{MN_STATS,"Statistics"},

		{MN_HDR3,"Build frob file"},
		{MN_CLEAN,"Delete all files"},

		{MN_BUILD,"Complete new build"},
		{MN_TEST,"Test a single text"},
		{MN_SC,"Register a subcorpus"},
		{MN_DEREG,"Deregister a subcorpus"},
		{MN_EXIT,"Exit"}

		}

	};	

                                                     

                

                                                     

#define DEFPARAM "corpus.prm"                                                     
#ifndef SERVER

main(int argc,char* argv[])            

{         

	int i, nerrs;             char dpath[_MAX_PATH]; BOOL b;

	if (argc>1) { b=CLine(argv[1],&nerrs); 
	corperr("Read PRM file from commandline\n");
        }
        else {b=CLine(DEFPARAM,&nerrs);
	corperr("Read PRM file from default PRM file\n");
        }     
	if (!b) {
		corperr("No PRM file\n");
		return 1;
	}
   strcpy(dpath,etcpath);
   strcat(dpath,corpname);
   strcat(dpath,".dsc");
   printf("Opening DSC file %s\n",dpath);
   if (!ReadDescFile(dpath)) {
   		corperr("No DSC file\n","");
   		return 1;
   	}
	GetParameters();

	/* ClearBuffers(); */

	if (bDebug) 

	{   

		time_t t=time(NULL);

		{ FILE *f1;
		f1=fopen("lockfile","r");
		if (f1) {
			fclose(f1);
		fLog=fopen("corpus.log","a");
			if (fLog) fprintf(fLog,"Reopened log file %s",asctime(localtime(&t)));}
		else {
		fLog=fopen("corpus.log","w");

		if (fLog != NULL) fprintf(fLog,"Opened log file %s",asctime(localtime(&t)));
		}}
	}	

	corperr("DSC file is %s\n",dpath);

	while ((i=Menu(&umenu)) != MN_EXIT)	

		UtilPerform(i);

	if (bDebug) 

	{     

		time_t t=time(NULL);

		if (fLog != NULL)

		{

		fprintf(fLog,"Closed log file %s",asctime(localtime(&t)));

		fclose(fLog);

		}

	}	             

/*	CleanUp(); */

	return 0;

}		      

#else

#endif



#ifdef SERVER	

/* Should be in server? */

void CleanUp(void)

{

	DelAllWL();

	return;

}

                                                

#endif

void corperr(char *s,...)
{     
#ifndef SERVER
	va_list dots;
	va_start(dots,s);
	vprintf(s,dots); 
	if (fLog != NULL) 
	  {
	    vfprintf(fLog,s,dots);
	    fflush(fLog);
	  }
#endif	
	return;
}	                  

            

          

void UtilMenu(void)

{                     

	int i;

	while ((i=Menu(&umenu)) != MN_MAIN) UtilPerform(i);

	return;

}	

         

void UtilPerform(int i)

{

	switch (i)

	{

                          

	case MN_FINDEX:

		MakeFIndex();

		break;                          

	case MN_INDEX:

		BuildIndex();

		break;                              

	case MN_HDR3:
		MakeFrob();
		break;	

	case MN_MERGE:

		MergeIndex();

		break;	      

	case MN_SORT:

		Sorts();

		break;	                             

	case MN_COMPRESS:

		Compression();

		break;	      

	case MN_DICT:

		Dictionary();

		break;	                      
		
	case MN_BIBL:
		
		Bibliography();
		
		break;	

	case MN_PINDEX:

		PackIndex();

		break;	
		
	case MN_SIG:
		IndexSig();
		break;
			

	case MN_STATS:

		Measure();

		break;	     

	case MN_CLEAN:

		Clean();

		break;

	case MN_TEST:
		{
			char l[10]; char c[10];
			printf("Enter code: ");
			gets(l);
			sscanf(l,"%s",c);
			BuildOneIndex(c);
			break;
		}

	case MN_SC:
		{
			char l[1000]; char c[1000];
			printf("Enter name: ");
			gets(l);
			sscanf(l,"%s",c);
			printf("Enter description: ");
			gets(l);
			SCReadAll();
			if (!SCRead(c,l)) {
				corperr("No such subcorpus");
				break;
			}
			printf("Registering %s\n",c);
			SCDictionary(c);
			SCWriteAll();
			break;
		}
	case MN_DEREG:
		{
			char c[1000]; char l[1000];
			printf("Enter name: ");
			gets(l);
			sscanf(l,"%s",c);
			SCReadAll();
			SCDel(c);
			printf("Deregistering %s\n",c);
			SCWriteAll();
			break;
		}

	case MN_BUILD:
		Clean();     
		corperr("Rescanning file list\n","");
		MakeFIndex();
		corperr("Building & merging .hid files\n","");
		BuildMerge();                   
		corperr("Sorting\n","");
		Sorts();
		corperr("Compressing index files\n","");
		Compression();       
		IndexSig();
		corperr("Making dictionary\n","");
		Dictionary();
		corperr("Packing file index\n","");
		PackIndex();                   
		corperr("Indexing bibliography","");
		Bibliography();
		corperr("Done\n","");
		break;		

	      case MN_BM:
		BuildMerge();
		break;

	}

	return;

}		         





	

void GetParameters(void)

{           

	GetIndex();

	if (fIndex != NULL) 
		printf("Opened index OK\n");
    else {
    	printf("No index: generating...\n");
    	MakeFIndex();
    }
    	
	printf("Found %i texts\n",ntexts);

	if (ntexts>MAXTEXTS) corperr("Too many texts\n","");


#ifndef unix

	_fmode=_O_BINARY;

#endif
	return;

}			





/*
void GetAccelTable(void)

{

  FILE* fAcc; char s[MAXWORD]; int type, extra; int ai=-1;

  char apath[_MAX_PATH];

  sprintf(apath,"%saccel",etcpath());

  fAcc=fopen(apath,"r");

  if (fAcc==NULL) return;

  while(fscanf(fAcc,"%s %i %i",s,&type,&extra)==3)

    {

      ai++;

      if (ai==ACCMAX) return;

      strcpy(acctab[ai].word,s);

      acctab[ai].type=type;

      acctab[ai].extra=extra;

      printf("Acclerate %s %i %i\n",s,type,extra);

    }

  nacc=ai+1;

  fclose(fAcc);

  return;

}
*/


void GetInclude(void)

{                                 

	int i=0;

	strcpy(incpath,etcpath);

	strcat(incpath,INCNAME);

	fInclude=fopen(incpath,"r");

	if (fInclude == NULL)

		{

		if (bDebug) 

			printf("No include file\n");

		ninc=0;	

		}

	else    

		{

		while(fscanf(fInclude,"%s\n",incf[i])==1) i++;

		fclose(fInclude);

		ninc=i;

        if (bDebug)

        	printf("Processed include file %s (%i entries)\n",incpath,ninc);

        }

    return;

}        	                    

                            

void GetExclude(void)

{       

	int i=0;

	strcpy(excpath,etcpath);

	strcat(excpath,EXCNAME);

	fExclude=fopen(excpath,"r");

	if (fExclude == NULL)

		{

		if (bDebug) 

			printf("No exclude file\n");

		nexc=0;	

		}

	else    

		{

		while(fscanf(fExclude,"%s",excf[i])==1) i++;

		fclose(fExclude);

		nexc=i;

        if (bDebug)

        	printf("Processed exclude file %s (%i entries)\n",excpath,nexc);

        }

    return;

}        	                    



BOOL Excluded(char* code)

{

	int i=0;

	if (!strcmp(code,"000")) return FALSE;

	if (nexc > 0)

		for (i=0;i<nexc;i++)

			if (!strcmp(code,excf[i])) break;

	if (i<nexc) return TRUE;

	if (ninc==0) return FALSE;

	for (i=0;i<ninc;i++)

		if (!strcmp(code,incf[i])) break;

	return i>=ninc;

}			

#ifdef unix

#define DELCMD "rm -f"

#define SEPCHAR '/'

#else

#define DELCMD "del"

#define SEPCHAR '\\'

#endif



                  





BOOL GetIndexDir(int i,char* path)

{

  int s;
  if (IndexDir(i*100)==NULL) return FALSE;

  strcpy(path,IndexDir(i*100));

  if (path[s=(strlen(path)-1)]==SEPCHAR) path[s]=0;

  return TRUE;

}                                 

                

#ifdef unix                

#define ALLFILES "*"

#else

#define ALLFILES "*.*"

#endif

          

#ifndef SERVER

void Clean(void)

{

  char cmd[_MAX_PATH]; int i;

	char path[_MAX_PATH];

	sprintf(cmd,DELCMD " %s*.idx",etcpath);

	system(cmd);

	for (i=0;i<NDirs();i++)

	  {

	    if (!GetIndexDir(i,path)) continue;

	    if (CrDir(path))

	      {

		sprintf(cmd,DELCMD " %s%c" ALLFILES,path,SEPCHAR);

//		system(cmd);

	      }

	  }

	return;

}       



BOOL CrDir(char* path)      

{

#ifdef unix

	if (mkdir(path,0744)==-1) return errno==EEXIST;

#else

	if (mkdir(path)==-1) return errno==EEXIST;

#endif

	return TRUE;
}

			

#endif

void GetPath(char* code,char* path)

{

	char code1[MAX_CODE+1];

	rewind(fIndex);

/*	while (fscanf(fIndex,"%s %*s %s\n",code1,path)==2)

		if (!strcmp(code,code1)) break; */

	strcmp(code,code1);

	return;

}		



void GetIndex(void)

{                   

	char idxpath[_MAX_PATH];

  char code[MAX_CODE+1];

	strcpy(idxpath,etcpath);

	strcat(idxpath,INDEXNAME);

	fIndex=fopen(idxpath,"r");
	if (fIndex==NULL) return;
#ifndef unix

	_fmode=_O_BINARY;

#endif

	ntexts=0;

	while(fscanf(fIndex,"%s %*s %*s\n",code)==1) ntexts++;

	rewind(fIndex);

	return;

}			



