/*
 * $Id: corpprm.c,v 1.4 1996/05/12 23:36:15 scotty Rel $
 *
 * $Log: corpprm.c,v $
 * Revision 1.4  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.3  1996/02/26 21:05:13  scotty
 * Imported some declarations from corphash.c which were never used
 * there; mostly configuration parameters.
 *
 * Revision 1.2  1996/02/14 22:01:04  scotty
 * Defines *PATH cpp variables for DOS.
 *
 * Revision 1.1  1996/01/30 20:48:12  scotty
 * Initial revision
 *
 */
#include "corpinc.h"

static char rcsid[] = "$Id: corpprm.c,v 1.4 1996/05/12 23:36:15 scotty Rel $";


/* bits from corphash.c */
extern int           nroots;
extern int           nroots2;
extern char          rpath[][_MAX_PATH];
extern char          rpath2[][_MAX_PATH];
extern unsigned int  rlim[];
extern unsigned int  rlim2[];
extern int           igran;

BOOL oldnames=FALSE;
BOOL c6=FALSE;  
BOOL oldid=FALSE;
BOOL oldcr=FALSE;
BOOL stags=TRUE;

#if !defined(__unix__)
#define ETCPATH "\\sgml\\index\\"
#define TMPPATH "\\sgml\\index\\"
#define SRTPATH "\\sgml\\index\\"
#define ACCPATH "\\sgml\\accounts\\"
#define TXTPATH "\\sgml\\docs\\"
#define BIBNAME "bibliog.sgm"
#define CHDPATH "\\sgml\\etc\\"
#endif /* __unix__ */

char  accpath[_MAX_PATH] = ACCPATH;
char  bibname[_MAX_PATH] = BIBNAME;
char  chdpath[_MAX_PATH] = CHDPATH;
char  etcpath[_MAX_PATH] = ETCPATH;
char  srtpath[_MAX_PATH] = SRTPATH;
char  tmppath[_MAX_PATH] = TMPPATH;
char  txtpath[_MAX_PATH] = TXTPATH;
char  corpname[MAXCORPNAME];
char  website[_MAX_PATH];

#if !defined(BNC_PORT)
# define BNC_PORT 7000
#endif

int            port = BNC_PORT;
int            timeout = 600;
int            nbuff = 40;
int            kps = 0;
int            nback = 0;
BOOL           bSysLog = FALSE;

struct atab    acctab[ACCMAX];
int            nacc;
               
int npc;

struct _pcq pcqtab[MAXPCQ];	               
               
char           incf[MAXINC][MAX_CODE + 1];
char           excf[MAXEXC][MAX_CODE + 1];
char   omit[MAXOMIT][MAX_CODE+1];
int            ninc;
int            nexc;        
int nomit=0;

#define IGRAN 50
int            xgran = IGRAN;

BOOL CLBuff(char *buff);

BOOL CLine(char *file,int* nerrs)
{
   FILE    *f;
   char     buffer[100];

   nroots = 0;
   nacc = 0;
   npc=0;
   ninc = 0;
   nexc = 0;                          
   nerrs=0;

   if (file[0] == 0)
      return FALSE;

   f = fopen(file, "r");

   if (f == NULL)
      return FALSE;

   while (fgets(buffer, sizeof(buffer), f))
      if (!CLBuff(buffer)) nerrs++;
   fclose(f);
   hashcharmask=((2<<(hashshift-1))-1);
   hashlastmask=((2<<(hashlast-1))-1);
	hashrange=(2<<(nhashsig*hashshift+hashlast-1));

	if (igran==0) igran=hashrange;
//	printf("igran=%d\n",igran);

   return TRUE;
}              

void wdcpy(char* s1,char* s)
{
	int k;
	strcpy(s1,s);
	k=strlen(s1);
	while (k>0) {
		if (!isspace(s1[k-1])) break;
		s1[k-1]=0;
		k--;
	}
}

//	while (*s && !isspace(*s)) *(s1++)=*(s++);
//	*s1=0;
	


enum pa {
   PA_ETC,  PA_TMP,  PA_ACC,  PA_TXT,  PA_IDX,  PA_IDX2, PA_TAG,
   PA_BIB,  PA_PORT, PA_BACK, PA_HDR,  PA_SORT, PA_ACL,  PA_INC,
   PA_EXC,  PA_TOT,  PA_BUF,  PA_LOG,  PA_GRAN, PA_NAME, PA_ON, PA_C6, 
   PA_WEB, PA_PCQ,  PA_OMIT, PA_OI, PA_OCR,
   PA_NHASH,PA_NHASHSIG,PA_HASHSHIFT,PA_HASHLAST,PA_IGRAN,
   PA_ILOC,PA_MAX
};

#define NPARAMS PA_MAX

char *param[NPARAMS] = {
   "ETC",   "TMP",   "ACC",   "TXT",   "IDX",   "IDS",   "TAG",
   "BIB",   "PORT",  "BACK",  "HDR",   "SORT",  "ACL",   "INC",
   "EXC",   "TOT",   "BUF",   "LOG",   "GRAN", "NAME", "OLDNAMES", "C6",
   "WEB", "PCQ", "OMIT", "OLDID","OLDCR","NHASH","NHASHSIG",
   "HASHSHIFT","HASHLAST","IGRAN","ILOC"
};

int pfind(char *p)
{
   int   i;

   for (i = 0; i < NPARAMS; i++)
      if (!strcmp(p, param[i]))
	 break;

   return i;
}

BOOL CLBuff(char *buff)
{
   char  param[30],
         val[_MAX_PATH + 30];
   int   i,
         j;
	i=0;
	while (buff[i]) {if (buff[i]=='\n'||buff[i]=='#'||buff[i]=='\r') buff[i]=0;i++;}
	 i = 0; 
	 while (buff[i] && isspace(buff[i])) i++;
	if (buff[i]==0) return TRUE;
   while (buff[i] && isalnum(buff[i])) {
      param[i] = buff[i];
      i++;
   }                                           
   param[i] = 0;
	 while (buff[i] && isspace(buff[i])) i++;
	if (buff[i]!='=') return FALSE;   
   i++;
   j = 0;

	while (buff[i])
      val[j++] = buff[i++];

   val[j] = 0;

/*	sscanf(buff,"%[^=]=%s",param,val); */

   switch (pfind(param)) {

    case PA_ETC:
      wdcpy(etcpath, val);
      break;

    case PA_TMP:
      wdcpy(tmppath, val);
      break;

    case PA_SORT:
      wdcpy(srtpath, val);
      break;

    case PA_ACC:
      wdcpy(accpath, val);
      break;

   case PA_HDR:
      wdcpy(chdpath, val);
      break;

   case PA_BIB:
      wdcpy(bibname, val);
      break;

   case PA_TXT:
      wdcpy(txtpath, val);
      break;

   case PA_IDX:
      i = 0;

      while (val[i] != ',' && val[i] != 0) {
         rpath[nroots][i] = val[i];
         i++;
      }

      rpath[nroots][i] = 0;
      i++;

      rlim[nroots] = atoi(val + i);
/*		sscanf(val,"%s,%d",rpath[nroots],&rlim[nroots]); */
      nroots++;
      break;

/*
    case PA_IDX2:
      i = 0;
      while (val[i] != ',' && val[i] != 0) {
         rpath2[nroots2][i] = val[i];
         i++;
      }
      i++;
      rlim2[nroots] = atoi(val + i);
      nroots2++;
      break;

    case PA_TAG:
      kps = atoi(val);
      if (kps != 1)
         kps = 0;
      break;
*/
    case PA_PORT:
      port = atoi(val);
      break;

    case PA_BACK:
      nback = atoi(val);
      break;

    case PA_ACL:
      i = 0;
      if (nacc >= ACCMAX)
         break;
      while (val[i] != 0 && val[i] != ',') {
         acctab[nacc].word[i] = val[i];
         i++;
      }
      acctab[nacc].word[i] = 0;
      if (val[i] == 0)
         break;
      i++;
      acctab[nacc].type = 0;
      while (isdigit(val[i])) {
         acctab[nacc].type = 10 * acctab[nacc].type + val[i] - '0';
         i++;
      }
      if (val[i] == 0)
         break;
      i++;
      acctab[nacc].extra = 0;
      while (isdigit(val[i])) {
         acctab[nacc].extra = 10 * acctab[nacc].extra + val[i] - '0';
         i++;
      }
//	  SGMLFold(acctab[nacc].word);
      nacc++;
      break;

    case PA_INC:
      wdcpy(incf[ninc++], val);
      break;

    case PA_EXC:
      wdcpy(excf[ninc++], val);
      break;

    case PA_TOT:
      timeout = atoi(val);
      break;

    case PA_BUF:
      nbuff = atoi(val);
      break;

    case PA_LOG:
      bSysLog = atoi(val);
      break;

    case PA_GRAN:
      xgran = atoi(val);
      break;                                         
      
    case PA_IGRAN:
      igran = atoi(val);
      break;                                         
      
	case PA_NAME:
		wdcpy(corpname,val);
		break;                                                       
		
	case PA_ON:	
		oldnames=atoi(val);
		break;
    
    case PA_OI:
        oldid=atoi(val);
        break;
		
    case PA_OCR:
        oldcr=atoi(val);
        break;
		
	case PA_C6:
		c6=atoi(val);
		break;
			
	case PA_WEB:
		wdcpy(website,val);
		break;

	case PA_OMIT:
		strcpy(omit[nomit++],val);
		break;
		
	case PA_PCQ:                                        
	{   
		int i=0; int j=0;
		while (val[j] && (val[j] != ',')) pcqtab[npc].elt[i++]=val[j++];
		if (val[j]==0) break; else j++;                                    
		pcqtab[npc].elt[i]=0;
		i=0;
		while (val[j] && (val[j] != ',')) pcqtab[npc].att[i++]=val[j++];
		if (val[j]==0) break; else j++;
		pcqtab[npc].att[i]=0;
		i=0;
		while (val[j] && (val[j] != ',')) pcqtab[npc].attval[i++]=val[j++];
		if (val[j]==0) break; else j++;
		pcqtab[npc].attval[i]=0;
		i=0;
		pcqtab[npc].val=0;
		while (val[j] &&(val[j] != ',')) pcqtab[npc].val=10*pcqtab[npc].val+val[j++]-'0';
		if (val[j]==0) break; else j++;
		while (val[j]) pcqtab[npc].cql[i++]=val[j++];
		pcqtab[npc].cql[i]=0;
		pcqtab[npc].ns=pcqtab[npc].nt=-1;
		npc++;
		break;
	}	
	case PA_NHASH:
		nhash=atoi(val);
		break;
	case PA_NHASHSIG:
		nhashsig=atoi(val);
		break;
	case PA_HASHLAST:
		hashlast=atoi(val);
		break;
	case PA_HASHSHIFT:
		hashshift=atoi(val);
		break;
	case PA_ILOC:
		maxiloc=atoi(val);
		break;
    default:
      return FALSE;
   }                       
   return TRUE;
}

void PCQFile(int n,char file[])
{                                
	sprintf(file,"%spcq%d.sqy",etcpath,n);
}	                                     

BOOL omitted(char* code) {
	int i;
	for (i=0;i<nomit;i++) 
		if (!_stricmp(code,omit[i])) return TRUE;
	return FALSE;
}		
		
